#if !defined(_VPFMISC_)
#define _VPFMISC_ 1

#define graphic_mode() \
	( (getgraphmode() < 0) ? 0 : 1)

void *vpfmalloc( unsigned long size );

void vpffree( void *ptr );

#ifdef __MSDOS__
void get_display_position( int *x, int *y, window_type window );
#endif

void displayinfo( char *text[],
		  int  nlines );

void no_study_area(void);

void no_map_displayed(void);

void display_message(char *str);

dms_type float_to_dms( double coord );

double dms_to_float( dms_type coord );

char *dms_string( dms_type coord, int seconds );

void out_dms( dms_type coord, int x, int y, int dir, int seconds );

int strpos( char *str, char ch );

boolean fwithin( float x,
	     float y,
	     extent_type extent );

boolean contained( extent_type extent1,
	       extent_type extent2 );

void memleft(void);

#ifdef __MSDOS__
window_type info_window( char *text );
#endif

float distance( double lat1, double lon1, double lat2, double lon2,
		int units );

char *rightjust( char *str );

char *leftjust( char *str );

boolean displayerror( char *text[],
		      int  nlines );

int printer_ready(void);

int printer_ok(void);

int is_primitive( char *name );

int is_simple_feature( char *name );

int is_complex_feature( char *name );

int is_feature( char *name );

int feature_type( char *name );

int is_join( char *name );

int primitive_class( char *name );

#endif
